require_dependency "klastera/application_controller"

module Klastera
  class ClustersController < ApplicationController
    before_action :set_cluster, only: %i[ edit update destroy transfer ]
    before_action :set_clusters, only: %i[ index ]

    def index; end

    def new
      @cluster = ::Cluster.new
    end

    def edit; end

    def transfer
      @transfer = Transfer.new
    end

    def create
      @cluster = ::Cluster.new(cluster_params)
      if @cluster.save
        @cluster = ::Cluster.new
        set_clusters
      end
    end

    def update
      if @cluster.update(cluster_params)
        set_clusters
      end
    end

    def destroy
      new_cluster_id = params.require(:transfer).permit(:new_cluster_id).values.first rescue nil
      @transfer = Transfer.new( current_cluster: @cluster, new_cluster_id: new_cluster_id )
      if @transfer.valid?
        if @transfer.apply!
          @cluster.destroy
        end
        set_clusters
      end
    end

    private
      def set_cluster
        @cluster = ::Cluster.find(params[:id])
      end

      def set_clusters
        @clusters = cluster_organization.clusters
      end

      def cluster_params
        parameters = params.require(:cluster).permit(:nid, :name, :color, :order)
        parameters[:organization_id]=cluster_organization.id
        parameters
      end
  end
end