module Klastera
  module ApplicationHelper
    def ac_errors_as_html_list(errors)
      array_as_html_list(
        errors.messages.inject([]) do |array,(attr,errors_array)|
          array.concat(errors_array)
          array
        end
      )
    end

    def array_as_html_list(array)
      "<ul style='padding:0;'><li>#{array.join("</li><li>")}</li></ul>".html_safe
    end

    def method_missing(method, *args, &block)
      if method.to_s.end_with?('_path') or method.to_s.end_with?('_url')
        if main_app.respond_to?(method)
          main_app.send(method, *args)
        else
          super
        end
      else
        super
      end
    end

    def respond_to?(method, include_priv=false)
      if method.to_s.end_with?('_path') or method.to_s.end_with?('_url')
        if main_app.respond_to?(method,include_priv)
          true
        else
          super
        end
      else
        super
      end
    end
  end
end
