module Klastera::Concerns::ClusterEntity
  extend ActiveSupport::Concern

  included do
    self.table_name = 'cluster_entities'
    belongs_to :entity, polymorphic: true
    belongs_to :cluster, class_name: "::Cluster"
  end
  
  module ClassMethods
    def left_join_sources_of(scope_klass)
      scope_klass_arel_table = scope_klass.arel_table
      scope_klass_arel_table.join(arel_table, Arel::Nodes::OuterJoin).on(
        scope_klass_arel_table[:id].eq(arel_table[:entity_id]), arel_table[:entity_type].eq(scope_klass.name)
      ).join_sources
    end
  end
end